This documentation is automatically generated by online-judge-tools/verification-helper
#define PROBLEM "https://judge.yosupo.jp/problem/aplusb"
#include "my_template.hpp"
#include "alg/monoid/min.hpp"
#include "ds/segtree/dynamic_segtree_sparse.hpp"
#include "random/base.hpp"
void test() {
using Mono = Monoid_Min<int>;
int id = Mono::id();
FOR(100) {
int N = RNG(1, 100);
vc<int> A(N, id);
Dynamic_SegTree_Sparse<Mono, false> X(0, N);
int root = 0;
int Q = RNG(1, 1000);
FOR(Q) {
int t = RNG(0, 4);
int L = RNG(0, N);
int R = RNG(0, N);
if (L > R) swap(L, R);
++R;
if (t == 0) {
int i = RNG(0, N);
int x = RNG(1, 100);
root = X.set(root, i, x);
A[i] = x;
}
if (t == 1) {
int i = RNG(0, N);
int x = RNG(1, 100);
root = X.multiply(root, i, x);
chmin(A[i], x);
}
if (t == 2) {
vc<int> B = {A.begin() + L, A.begin() + R};
assert(X.prod(root, L, R) == MIN(B));
}
if (t == 3) {
// max_right
int LIM = RNG(1, 100);
auto check = [&](auto e) -> bool { return e >= LIM; };
int naive = [&]() -> int {
ll mi = id;
FOR(i, L, N) {
chmin(mi, A[i]);
if (mi < LIM) return i;
}
return N;
}();
assert(naive == X.max_right(root, check, L));
}
}
}
}
void solve() {
int a, b;
cin >> a >> b;
cout << a + b << "\n";
}
signed main() {
test();
solve();
return 0;
}#line 1 "test/1_mytest/dynamic_segtree_sparse.test.cpp"
#define PROBLEM "https://judge.yosupo.jp/problem/aplusb"
#line 1 "my_template.hpp"
#if defined(USE_PCH)
#include <my_template_compiled.hpp>
#else
#if defined(__GNUC__)
#include <bits/allocator.h>
#pragma GCC optimize("Ofast,unroll-loops")
#if !defined(MASPY_NON_AVX2)
#pragma GCC target("avx2,popcnt")
#endif
#endif
#include <bits/stdc++.h>
#include <cassert>
using namespace std;
using ll = long long;
using u8 = uint8_t;
using u16 = uint16_t;
using u32 = uint32_t;
using u64 = uint64_t;
using i128 = __int128;
using u128 = unsigned __int128;
using f128 = __float128;
template <class>
constexpr bool dependent_false = false;
template <class T>
constexpr T infty = [] {
static_assert(dependent_false<T>, "infty<T> is not defined");
return T{};
}();
template <>
constexpr int infty<int> = 1'010'000'000;
template <>
constexpr ll infty<ll> = 2'020'000'000'000'000'000;
template <>
constexpr u32 infty<u32> = infty<int>;
template <>
constexpr u64 infty<u64> = infty<ll>;
template <>
constexpr i128 infty<i128> = i128(infty<ll>) * 2'000'000'000'000'000'000;
template <>
constexpr double infty<double> = infty<i128>;
template <>
constexpr long double infty<long double> = infty<i128>;
using pi = pair<ll, ll>;
using vi = vector<ll>;
template <class T>
using vc = vector<T>;
template <class T>
using vvc = vector<vc<T>>;
template <class T>
using vvvc = vector<vvc<T>>;
template <class T>
using vvvvc = vector<vvvc<T>>;
template <class T>
using pq_max = priority_queue<T>;
template <class T>
using pq_min = priority_queue<T, vector<T>, greater<T>>;
#define vv(type, name, h, ...) \
vector<vector<type>> name(h, vector<type>(__VA_ARGS__))
#define vvv(type, name, h, w, ...) \
vector<vector<vector<type>>> name( \
h, vector<vector<type>>(w, vector<type>(__VA_ARGS__)))
#define vvvv(type, name, a, b, c, ...) \
vector<vector<vector<vector<type>>>> name( \
a, vector<vector<vector<type>>>( \
b, vector<vector<type>>(c, vector<type>(__VA_ARGS__))))
// https://trap.jp/post/1224/
#define FOR1(a) for (ll _ = 0; _ < ll(a); ++_)
#define FOR2(i, a) for (ll i = 0; i < ll(a); ++i)
#define FOR3(i, a, b) for (ll i = a; i < ll(b); ++i)
#define FOR1_R(a) for (ll i = ll(a) - 1; i >= ll(0); --i)
#define FOR2_R(i, a) for (ll i = ll(a) - 1; i >= ll(0); --i)
#define FOR3_R(i, a, b) for (ll i = ll(b) - 1; i >= ll(a); --i)
#define overload3(a, b, c, d, ...) d
#define FOR(...) overload3(__VA_ARGS__, FOR3, FOR2, FOR1)(__VA_ARGS__)
#define FOR_R(...) overload3(__VA_ARGS__, FOR3_R, FOR2_R, FOR1_R)(__VA_ARGS__)
#define all(x) (x).begin(), (x).end()
#define len(x) ll(x.size())
#define elif else if
#define eb emplace_back
#define mp make_pair
#define mt make_tuple
#define fi first
#define se second
#define stoi stoll
// require y > 0
template <typename T>
T floor(T x, T y) {
return x / y - (x % y < 0);
}
// require y > 0
template <typename T>
T ceil(T x, T y) {
return (x / y) + (x % y > 0);
}
// require y > 0
template <typename T>
T bmod(T x, T y) {
T r = x % y;
return (r < 0 ? r + y : r);
}
// require y > 0
template <typename T>
pair<T, T> divmod(T x, T y) {
T q = x / y, r = x % y;
if (r < 0) --q, r += y;
return {q, r};
}
constexpr auto TEN = [] {
array<u64, 20> A{};
A[0] = 1;
for (int i = 1; i < 20; ++i) A[i] = 10 * A[i - 1];
return A;
}();
template <typename T, typename U>
T SUM(const U &A) {
return std::accumulate(A.begin(), A.end(), T{});
}
#define MIN(v) *min_element(all(v))
#define MAX(v) *max_element(all(v))
template <class C, class T>
inline long long LB(const C &c, const T &x) {
return lower_bound(c.begin(), c.end(), x) - c.begin();
}
template <class C, class T>
inline long long UB(const C &c, const T &x) {
return upper_bound(c.begin(), c.end(), x) - c.begin();
}
#define UNIQUE(x) sort(all(x)), x.erase(unique(all(x)), x.end())
template <typename T>
T POP(deque<T> &que) {
T a = que.front();
que.pop_front();
return a;
}
template <class T, class Container, class Compare>
T POP(priority_queue<T, Container, Compare> &que) {
T a = que.top();
que.pop();
return a;
}
template <typename T>
T POP(vc<T> &que) {
T a = que.back();
que.pop_back();
return a;
}
template <typename F>
i128 binary_search(F check, i128 ok, i128 ng, bool check_ok = true) {
if (check_ok) assert(check(ok));
while (1) {
i128 x = (ok + ng) / 2;
if (x == ok || x == ng) break;
(check(x) ? ok : ng) = x;
}
return ok;
}
template <typename F>
double binary_search_real(F check, double ok, double ng, int iter = 100) {
FOR(iter) {
double x = (ok + ng) / 2;
(check(x) ? ok : ng) = x;
}
return (ok + ng) / 2;
}
template <class T, class S>
inline bool chmax(T &a, const S &b) {
T c = max<T>(a, b);
bool changed = (c != a);
a = c;
return changed;
}
template <class T, class S>
inline bool chmin(T &a, const S &b) {
T c = min<T>(a, b);
bool changed = (c != a);
a = c;
return changed;
}
// bit operations
int popcnt(int x) { return __builtin_popcount(x); }
int popcnt(u32 x) { return __builtin_popcount(x); }
int popcnt(ll x) { return __builtin_popcountll(x); }
int popcnt(u64 x) { return __builtin_popcountll(x); }
int popcnt_sgn(int x) { return (__builtin_parity(unsigned(x)) & 1 ? -1 : 1); }
int popcnt_sgn(u32 x) { return (__builtin_parity(x) & 1 ? -1 : 1); }
int popcnt_sgn(ll x) { return (__builtin_parityll(x) & 1 ? -1 : 1); }
int popcnt_sgn(u64 x) { return (__builtin_parityll(x) & 1 ? -1 : 1); }
// (0, 1, 2, 3, 4) -> (-1, 0, 1, 1, 2)
int topbit(int x) { return (x == 0 ? -1 : 31 - __builtin_clz(x)); }
int topbit(u32 x) { return (x == 0 ? -1 : 31 - __builtin_clz(x)); }
int topbit(ll x) { return (x == 0 ? -1 : 63 - __builtin_clzll(x)); }
int topbit(u64 x) { return (x == 0 ? -1 : 63 - __builtin_clzll(x)); }
// (0, 1, 2, 3, 4) -> (-1, 0, 1, 0, 2)
int lowbit(int x) { return (x == 0 ? -1 : __builtin_ctz(x)); }
int lowbit(u32 x) { return (x == 0 ? -1 : __builtin_ctz(x)); }
int lowbit(ll x) { return (x == 0 ? -1 : __builtin_ctzll(x)); }
int lowbit(u64 x) { return (x == 0 ? -1 : __builtin_ctzll(x)); }
template <typename T>
T kth_bit(int k) {
assert(0 <= k && k < int(8 * sizeof(T)));
return T(1) << k;
}
template <typename T>
bool has_kth_bit(T x, int k) {
assert(0 <= k && k < int(8 * sizeof(T)));
return x >> k & 1;
}
template <typename T>
struct all_bit {
static_assert(is_integral<T>::value);
T s;
all_bit(T s) : s(s) { assert(s >= 0); }
struct iter {
T s;
int operator*() const { return lowbit(s); }
void operator++() { s &= s - 1; }
bool operator!=(nullptr_t) const { return s; }
};
iter begin() const { return {s}; }
nullptr_t end() const { return nullptr; }
};
template <typename T>
struct all_subset {
static_assert(is_integral<T>::value);
T s;
all_subset(T s) : s(s) { assert(s >= 0); }
struct iter {
T s, t;
bool done = false;
T operator*() const { return t; }
void operator++() {
done = (t == 0);
t = (t - 1) & s;
}
bool operator!=(nullptr_t) const { return !done; }
};
iter begin() const { return {s, s}; }
nullptr_t end() const { return nullptr; }
};
constexpr u64 full_mask(int n) {
assert(0 <= n && n <= 64);
return n == 64 ? -1ULL : (1ULL << n) - 1;
}
u64 bit_reverse(u64 x) {
x = ((x & 0x5555555555555555ULL) << 1) | ((x >> 1) & 0x5555555555555555ULL);
x = ((x & 0x3333333333333333ULL) << 2) | ((x >> 2) & 0x3333333333333333ULL);
x = ((x & 0x0f0f0f0f0f0f0f0fULL) << 4) | ((x >> 4) & 0x0f0f0f0f0f0f0f0fULL);
x = ((x & 0x00ff00ff00ff00ffULL) << 8) | ((x >> 8) & 0x00ff00ff00ff00ffULL);
x = ((x & 0x0000ffff0000ffffULL) << 16) | ((x >> 16) & 0x0000ffff0000ffffULL);
x = (x << 32) | (x >> 32);
return x;
}
// ? は -1
vc<int> s_to_vi(const string &S, char first_char) {
vc<int> A(S.size());
FOR(i, S.size()) { A[i] = (S[i] != '?' ? S[i] - first_char : -1); }
return A;
}
template <typename T, typename U>
vc<T> cumsum(const vc<U> &A, int off = 1) {
int N = A.size();
vc<T> B(N + 1);
FOR(i, N) { B[i + 1] = B[i] + A[i]; }
if (off == 0) B.erase(B.begin());
return B;
}
// stable sort
template <typename T>
vc<int> argsort(const vc<T> &A) {
vc<int> ids(len(A));
iota(all(ids), 0);
sort(all(ids),
[&](int i, int j) { return (A[i] == A[j] ? i < j : A[i] < A[j]); });
return ids;
}
// A[I[0]], A[I[1]], ...
template <typename T>
vc<T> rearrange(const vc<T> &A, const vc<int> &I) {
vc<T> B(len(I));
FOR(i, len(I)) B[i] = A[I[i]];
return B;
}
template <typename T, typename... Vectors>
void concat(vc<T> &first, const Vectors &...others) {
first.reserve(first.size() + (others.size() + ... + 0));
(first.insert(first.end(), others.begin(), others.end()), ...);
}
// i128
template <class T, enable_if_t<is_same_v<T, i128>, int> = 0>
constexpr i128 abs(T x) {
return x < 0 ? -x : x;
}
constexpr i128 gcd(i128 a, i128 b) {
while (b != 0) {
i128 c = a % b;
a = b, b = c;
}
return abs(a);
}
#endif
#line 1 "alg/monoid/min.hpp"
// require: all values x satisfy x <= infty<E>
template <typename E>
struct Monoid_Min {
using X = E;
using value_type = X;
static constexpr X op(const X &x, const X &y) noexcept { return min(x, y); }
static constexpr X id() { return infty<E>; }
static constexpr bool commute = true;
};
#line 1 "ds/segtree/dynamic_segtree_sparse.hpp"
// 常にほとんどの要素が id であることが保証されるような動的セグ木
// したがって、default_prod の類は持たせられず、acted monoid も一般には扱えない
// 追加 N 回のときノード数 N 以下が保証される
template <typename Monoid, bool PERSISTENT>
struct Dynamic_SegTree_Sparse {
using MX = Monoid;
using X = typename MX::value_type;
struct Node {
int ch[2];
ll idx;
X prod, x;
};
const ll L0, R0;
static constexpr int NIL = 0;
vc<Node> node;
vc<int> FREE;
Dynamic_SegTree_Sparse(ll L0, ll R0) : L0(L0), R0(R0) { reset(); }
void reserve(int n) { node.reserve(n + 1); }
void reset() {
node.clear(), FREE.clear();
node.eb(Node{{NIL, NIL}, 0, MX::id(), MX::id()}); // NIL
}
// 木 dp のマージのときなどに使用すると MLE 回避できることがある
// https://codeforces.com/problemset/problem/671/D
void free_subtree(int c) {
assert(c != NIL);
auto dfs = [&](auto &dfs, int c) -> void {
if (c == NIL) return;
dfs(dfs, node[c].ch[0]), dfs(dfs, node[c].ch[1]);
FREE.eb(c);
};
dfs(dfs, c);
}
inline int new_root() { return NIL; }
inline int new_node(ll idx, const X x) {
if (!FREE.empty()) {
int id = POP(FREE);
node[id].ch[0] = node[id].ch[1] = NIL;
node[id].idx = idx, node[id].x = x, node[id].prod = x;
return id;
}
node.eb(Node{{NIL, NIL}, idx, x, x});
return int(node.size()) - 1;
}
inline Node operator[](int i) const { return node[i]; }
X prod(int root, ll l, ll r) {
assert(L0 <= l && l <= r && r <= R0);
if (root == NIL || l == r) return MX::id();
X x = MX::id();
prod_rec(root, L0, R0, l, r, x);
return x;
}
X prod_all(int root) { return (root == NIL ? MX::id() : node[root].prod); }
int set(int root, ll i, const X &x) {
assert(L0 <= i && i < R0);
return set_rec(root, L0, R0, i, x);
}
int multiply(int root, ll i, const X &x) {
assert(L0 <= i && i < R0);
return multiply_rec(root, L0, R0, i, x);
}
template <typename F>
ll max_right(int root, F check, ll L) {
assert(L0 <= L && L <= R0 && check(MX::id()));
X x = MX::id();
return max_right_rec(root, check, L0, R0, L, x);
}
template <typename F>
ll min_left(int root, F check, ll R) {
assert(L0 <= R && R <= R0 && check(MX::id()));
X x = MX::id();
return min_left_rec(root, check, L0, R0, R, x);
}
vc<pair<ll, X>> get_all(int root) {
vc<pair<ll, X>> res;
auto dfs = [&](auto &dfs, int c) -> void {
if (c == NIL) return;
dfs(dfs, node[c].ch[0]);
res.eb(node[c].idx, node[c].x);
dfs(dfs, node[c].ch[1]);
};
dfs(dfs, root);
return res;
}
X get(int root, ll idx) {
auto dfs = [&](auto &dfs, int c) -> X {
if (c == NIL) return MX::id();
if (idx == node[c].idx) return node[c].x;
return dfs(dfs, node[c].ch[idx > node[c].idx]);
};
return dfs(dfs, root);
}
private:
inline void update(int c) {
node[c].prod = node[c].x;
node[c].prod = MX::op(node[node[c].ch[0]].prod, node[c].prod);
node[c].prod = MX::op(node[c].prod, node[node[c].ch[1]].prod);
}
inline int clone(int c) {
if constexpr (!PERSISTENT)
return c;
else {
if (c == NIL) return c;
node.eb(node[c]);
return int(node.size()) - 1;
}
}
int set_rec(int c, ll l, ll r, ll i, X x) {
if (c == NIL) return new_node(i, x);
c = clone(c);
if (node[c].idx == i) {
node[c].x = x;
update(c);
return c;
}
ll m = (l + r) / 2;
if (i < m) {
if (node[c].idx < i) swap(node[c].idx, i), swap(node[c].x, x);
node[c].ch[0] = set_rec(node[c].ch[0], l, m, i, x);
}
if (m <= i) {
if (i < node[c].idx) swap(node[c].idx, i), swap(node[c].x, x);
node[c].ch[1] = set_rec(node[c].ch[1], m, r, i, x);
}
update(c);
return c;
}
int multiply_rec(int c, ll l, ll r, ll i, X x) {
if (c == NIL) return new_node(i, x);
c = clone(c);
if (node[c].idx == i) {
node[c].x = MX::op(node[c].x, x);
update(c);
return c;
}
ll m = (l + r) / 2;
if (i < m) {
if (node[c].idx < i) swap(node[c].idx, i), swap(node[c].x, x);
node[c].ch[0] = multiply_rec(node[c].ch[0], l, m, i, x);
}
if (m <= i) {
if (i < node[c].idx) swap(node[c].idx, i), swap(node[c].x, x);
node[c].ch[1] = multiply_rec(node[c].ch[1], m, r, i, x);
}
update(c);
return c;
}
void prod_rec(int c, ll l, ll r, ll ql, ll qr, X &x) {
chmax(ql, l), chmin(qr, r);
if (ql >= qr || c == NIL) return;
if (l == ql && r == qr) {
x = MX::op(x, node[c].prod);
return;
}
ll m = (l + r) / 2;
prod_rec(node[c].ch[0], l, m, ql, qr, x);
if (ql <= (node[c].idx) && (node[c].idx) < qr) x = MX::op(x, node[c].x);
prod_rec(node[c].ch[1], m, r, ql, qr, x);
}
template <typename F>
ll max_right_rec(int c, const F &check, ll l, ll r, ll ql, X &x) {
if (c == NIL || r <= ql) return R0;
if (ql <= l && check(MX::op(x, node[c].prod))) {
x = MX::op(x, node[c].prod);
return R0;
}
ll m = (l + r) / 2;
ll k = max_right_rec(node[c].ch[0], check, l, m, ql, x);
if (k != R0) return k;
if (ql <= node[c].idx) {
x = MX::op(x, node[c].x);
if (!check(x)) return node[c].idx;
}
return max_right_rec(node[c].ch[1], check, m, r, ql, x);
}
template <typename F>
ll min_left_rec(int c, const F &check, ll l, ll r, ll qr, X &x) {
if (c == NIL || qr <= l) return L0;
if (check(MX::op(node[c].prod, x))) {
x = MX::op(node[c].prod, x);
return L0;
}
ll m = (l + r) / 2;
ll k = min_left_rec(node[c].ch[1], check, m, r, qr, x);
if (k != L0) return k;
if (node[c].idx < qr) {
x = MX::op(node[c].x, x);
if (!check(x)) return node[c].idx + 1;
}
return min_left_rec(node[c].ch[0], check, l, m, qr, x);
}
};
#line 1 "random/base.hpp"
u64 RNG_64() {
static u64 x_ = u64(chrono::duration_cast<chrono::nanoseconds>(
chrono::high_resolution_clock::now().time_since_epoch())
.count()) *
10150724397891781847ULL;
x_ ^= x_ << 7;
return x_ ^= x_ >> 9;
}
u64 RNG(u64 lim) {
assert(lim > 0);
return RNG_64() % lim;
}
ll RNG(ll l, ll r) {
assert(l < r);
return l + RNG_64() % (r - l);
}
#line 6 "test/1_mytest/dynamic_segtree_sparse.test.cpp"
void test() {
using Mono = Monoid_Min<int>;
int id = Mono::id();
FOR(100) {
int N = RNG(1, 100);
vc<int> A(N, id);
Dynamic_SegTree_Sparse<Mono, false> X(0, N);
int root = 0;
int Q = RNG(1, 1000);
FOR(Q) {
int t = RNG(0, 4);
int L = RNG(0, N);
int R = RNG(0, N);
if (L > R) swap(L, R);
++R;
if (t == 0) {
int i = RNG(0, N);
int x = RNG(1, 100);
root = X.set(root, i, x);
A[i] = x;
}
if (t == 1) {
int i = RNG(0, N);
int x = RNG(1, 100);
root = X.multiply(root, i, x);
chmin(A[i], x);
}
if (t == 2) {
vc<int> B = {A.begin() + L, A.begin() + R};
assert(X.prod(root, L, R) == MIN(B));
}
if (t == 3) {
// max_right
int LIM = RNG(1, 100);
auto check = [&](auto e) -> bool { return e >= LIM; };
int naive = [&]() -> int {
ll mi = id;
FOR(i, L, N) {
chmin(mi, A[i]);
if (mi < LIM) return i;
}
return N;
}();
assert(naive == X.max_right(root, check, L));
}
}
}
}
void solve() {
int a, b;
cin >> a >> b;
cout << a + b << "\n";
}
signed main() {
test();
solve();
return 0;
}